# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PouleJsonldClassement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'context': 'OneOfPouleJsonldClassementContext',
        'id': 'str',
        'type': 'str',
        'stage_number': 'int',
        'name': 'str',
        'cdg': 'CdgJsonldClassement',
        'external_updated_at': 'datetime',
        'poule_unique': 'bool'
    }

    attribute_map = {
        'context': '@context',
        'id': '@id',
        'type': '@type',
        'stage_number': 'stage_number',
        'name': 'name',
        'cdg': 'cdg',
        'external_updated_at': 'external_updated_at',
        'poule_unique': 'poule_unique'
    }

    def __init__(self, context=None, id=None, type=None, stage_number=None, name=None, cdg=None, external_updated_at=None, poule_unique=None):  # noqa: E501
        """PouleJsonldClassement - a model defined in Swagger"""  # noqa: E501
        self._context = None
        self._id = None
        self._type = None
        self._stage_number = None
        self._name = None
        self._cdg = None
        self._external_updated_at = None
        self._poule_unique = None
        self.discriminator = None
        if context is not None:
            self.context = context
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if stage_number is not None:
            self.stage_number = stage_number
        if name is not None:
            self.name = name
        if cdg is not None:
            self.cdg = cdg
        if external_updated_at is not None:
            self.external_updated_at = external_updated_at
        if poule_unique is not None:
            self.poule_unique = poule_unique

    @property
    def context(self):
        """Gets the context of this PouleJsonldClassement.  # noqa: E501


        :return: The context of this PouleJsonldClassement.  # noqa: E501
        :rtype: OneOfPouleJsonldClassementContext
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this PouleJsonldClassement.


        :param context: The context of this PouleJsonldClassement.  # noqa: E501
        :type: OneOfPouleJsonldClassementContext
        """

        self._context = context

    @property
    def id(self):
        """Gets the id of this PouleJsonldClassement.  # noqa: E501


        :return: The id of this PouleJsonldClassement.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PouleJsonldClassement.


        :param id: The id of this PouleJsonldClassement.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this PouleJsonldClassement.  # noqa: E501


        :return: The type of this PouleJsonldClassement.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PouleJsonldClassement.


        :param type: The type of this PouleJsonldClassement.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def stage_number(self):
        """Gets the stage_number of this PouleJsonldClassement.  # noqa: E501


        :return: The stage_number of this PouleJsonldClassement.  # noqa: E501
        :rtype: int
        """
        return self._stage_number

    @stage_number.setter
    def stage_number(self, stage_number):
        """Sets the stage_number of this PouleJsonldClassement.


        :param stage_number: The stage_number of this PouleJsonldClassement.  # noqa: E501
        :type: int
        """

        self._stage_number = stage_number

    @property
    def name(self):
        """Gets the name of this PouleJsonldClassement.  # noqa: E501


        :return: The name of this PouleJsonldClassement.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PouleJsonldClassement.


        :param name: The name of this PouleJsonldClassement.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def cdg(self):
        """Gets the cdg of this PouleJsonldClassement.  # noqa: E501


        :return: The cdg of this PouleJsonldClassement.  # noqa: E501
        :rtype: CdgJsonldClassement
        """
        return self._cdg

    @cdg.setter
    def cdg(self, cdg):
        """Sets the cdg of this PouleJsonldClassement.


        :param cdg: The cdg of this PouleJsonldClassement.  # noqa: E501
        :type: CdgJsonldClassement
        """

        self._cdg = cdg

    @property
    def external_updated_at(self):
        """Gets the external_updated_at of this PouleJsonldClassement.  # noqa: E501


        :return: The external_updated_at of this PouleJsonldClassement.  # noqa: E501
        :rtype: datetime
        """
        return self._external_updated_at

    @external_updated_at.setter
    def external_updated_at(self, external_updated_at):
        """Sets the external_updated_at of this PouleJsonldClassement.


        :param external_updated_at: The external_updated_at of this PouleJsonldClassement.  # noqa: E501
        :type: datetime
        """

        self._external_updated_at = external_updated_at

    @property
    def poule_unique(self):
        """Gets the poule_unique of this PouleJsonldClassement.  # noqa: E501


        :return: The poule_unique of this PouleJsonldClassement.  # noqa: E501
        :rtype: bool
        """
        return self._poule_unique

    @poule_unique.setter
    def poule_unique(self, poule_unique):
        """Sets the poule_unique of this PouleJsonldClassement.


        :param poule_unique: The poule_unique of this PouleJsonldClassement.  # noqa: E501
        :type: bool
        """

        self._poule_unique = poule_unique

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PouleJsonldClassement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PouleJsonldClassement):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
